{
Emulate Extended Pascal's `WriteStr' procedure in Borland Pascal

- This unit allows you to use the comfortable formatting of Write
  for output into strings. This is similar as the WriteStr statement
  as defined in the Extended Pascal standard.

- Use it as:

  Write (st (<StringVar>)^, <output parameters>)

  (or with `Writeln' instead of `Write' if you want the CR/LF characters
  in the String).

- Do NOT use in any other way!

- With TP7.0, `st' accepts any string type, with earlier versions only
  strings without a declared length (i.e. of maximum length 255).

- A simple test program is appended at the end.

- `ReadStr' could probably be done very similarly.

- Tested with TP5.5, BP7.0 (real and protected mode).

- Note: This is BAD usage of the TFDD mechanism!

Copyright 1997-99 by Frank Heckenbach,
frank(at)pascal.gnu.de or fjf(at)gmx.de

This library is free software; you can redistribute it and/or modify
it under the terms of the GNU Library General Public License as
published by the Free Software Foundation, version 2.

This library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library, see the file COPYING.LIB; if not,
write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.
}

unit WriteStr;

interface

uses Dos;

type
  PText = ^Text;

{$ifdef ver70} {$p+} {$endif}

function st (var s : String) : PText;

implementation

type
  PString = ^String;
  TWriteStrUserData = record
    StrP : PString;
    Max : Word;
    Fill : array [1 .. 10] of Byte
  end;

{$f+}

function WriteToStr (var f : TextRec) : Integer;
begin
  with f, TWriteStrUserData (UserData) do
    begin
      if BufPos > Max then BufPos := Max;
      Move (BufPtr^, StrP^ [Length (StrP^) + 1], BufPos);
      Inc (StrP^ [0], BufPos);
      Dec (Max, BufPos);
      BufPos := 0
    end;
  WriteToStr := 0
end;

function WriteStrDone (var f : TextRec) : Integer;
begin
  WriteStrDone := WriteToStr (f);
  FreeMem (@f, SizeOf (f)) { Ouch... ;-}
end;

{$f-}

function st (var s : String) : PText;
var p : PText;
begin
  s := '';
  New (p);
  with TextRec (p^), TWriteStrUserData (UserData) do
    begin
      Mode := fmOutput;
      BufSize := SizeOf (Buffer);
      BufPos := 0;
      BufPtr := @Buffer;
      InOutFunc := @WriteToStr;
      FlushFunc := @WriteStrDone;
      StrP := PString (@s);
      Max := {$ifdef ver70} High (s) {$else} $ff {$endif};
    end;
  st := p
end;

end.
